#pragma once

#include <cppmp/config.h>

#include "types.h"

namespace cppmp
{

    /**
     * @brief True boolean constant value.
     */
    constexpr true_t true_c;

    /**
     * @brief False boolean constant value.
     */
    constexpr false_t false_c;

    /**
     * @brief Zero size constant value,
     */
    constexpr zero_t zero_c;

    #ifdef cppmp_supports_variable_templates

    /**
     * @brief Boolean constant value.
     */
    template<bool B>
    constexpr bool_t<B> bool_c;

    /**
     * @brief Size constant value.
     */
    template<std::size_t I>
    constexpr size_t<I> size_c;

    #endif

}
